# Ansible Playbook  2.9
# Upgrade with pg_upgrade
---
- name: Verify whether PostgreSQL is stopped
  shell: |
    if pgrep -lx postgres; then
      exit 1
    else
      exit 0
    fi
  register: postgres_state
  until: postgres_state.rc == 0
  retries: 10
  delay: 5
  tags:
    - leader-upgrade
    - check-postgres-stop

- name: Check if version compatible
  shell: >
    {{ new_bindir }}/pg_upgrade --old-bindir {{ old_bindir }} --new-bindir {{ new_bindir}}
    --old-datadir {{ old_datadir }} --new-datadir {{ new_datadir }}
    -o "-c config_file={{ old_config }}" -O "-c config_file={{ new_config }}"
    --check --link
  register: check
  when: postgres_state.rc == 0
  tags:
    - leader-upgrade

- name: Fact
  set_fact:
    version_compatible: "{{ item | regex_search('Clusters are compatible') }}"
  with_items: "{{ check.stdout_lines }}"
  when: postgres_state.rc == 0
  tags:
    - leader-upgrade

- name: Upgrade Server
  shell: >
    {{ new_bindir }}/pg_upgrade --old-bindir {{ old_bindir }}
    --new-bindir {{ new_bindir}}
    --old-datadir {{ old_datadir }} --new-datadir {{ new_datadir }}
    -o "-c config_file={{ old_config }}" -O "-c config_file={{ new_config }}"
    --link
  register: upgraded
  when: version_compatible == 'Clusters are compatible'
  tags:
    - leader-upgrade
